//=========================================================
	DEVICE	ZXSPECTRUM128
	ORG	#6400
PROGBEG

BUFF1	EQU	#E000
BUFF2	EQU	BUFF1+3072

//------------------------------------------  , 
	LD	SP,#6400
	LD	BC,#7FFD
	LD	A,#17
	OUT	(C),A
//------------------------------------------   
	LD	HL,#5800
	LD	DE,#5801
	LD	BC,767
	LD	(HL),L
	LDIR
	LD	HL,#D800
	LD	DE,#D801
	LD	BC,767
	LD	(HL),L
	LDIR
//------------------------------------------  
	LD	HL,#4000	//6144
	LD	DE,(23796)
	LD	BC,#1805
	CALL	#3D13

	LD	HL,#C000	//6144
	LD	DE,(23796)
	LD	BC,#1805
	CALL	#3D13

//------------------------------------------  
	LD	HL,BUFF1	//3072
	LD	DE,(23796)
	LD	BC,#0C05
	CALL	#3D13

	LD	HL,BUFF2	//3072
	LD	DE,(23796)
	LD	BC,#0C05
	CALL	#3D13

	CALL	CALCATTR

//------------------------   
	DI
	LD	A,#BE
	LD	I,A
	IM	2
	LD	HL,#BE00
	LD	B,0
LL1	LD	(HL),#BF
	INC	HL
	DJNZ	LL1
	LD	(HL),#BF
	LD	HL,#BFBF
	LD	(HL),#C9
//------------------------
MAINLP	EI
	HALT
	CALL	PAUSE	;17
	CALL	ATTR0	;17
	LD	A,1
	OUT	(#FE),A
	EI
	HALT
	CALL	PAUSE
	CALL	ATTR1
	LD	A,1
	OUT	(#FE),A
	JP	MAINLP
//------------------------
PAUSE	
	LD	A,1
	OUT	(#FE),A
	//--------------
	LD	BC,722		;10	//741
PAUSE0	DEC	BC		;6
	LD	A,B		;4
	OR	C		;4
	JP	NZ,PAUSE0	;10 //24 - 17898+?/24
	DUP	5
	NOP
	EDUP
	//--------------
	LD	BC,#7FFD	;10
	LD	D,%00001000	;7
	LD	A,#17		;7
PAGE	EQU	$-1		;
	XOR	D		;4
	LD	(PAGE),A	;13
	OUT	(C),A		;12
	LD	E,A
	XOR	A
	OUT	(#FE),A
	LD	A,E
	RET			;10
//------------------------
//	DUP	16
//	LD	HL,0	;10
//	LD	(0),HL	;16 //416	6 
//	EDUP		
//	NOP		;4
//	NOP		;4
//	NOP		;4
//	NOP		;4
//	XOR	D	;4
//	OUT	(C),A	;12 //32	7  //103   //9888+1=9889  

CALCATTR
	LD	HL,ATTR0
	LD	DE,#5800
	LD	IX,BUFF1
	LD	IY,BUFF2+32
	CALL	CA00
	LD	HL,ATTR1
	LD	DE,#D800
	LD	IX,BUFF2
	LD	IY,BUFF1+32
	//------
CA00	LD	A,24
	//------
CA2	EX	AF,AF
	LD	C,4
	//------
CA1	PUSH	DE
	LD	B,16
	//------
CA0	LD	(HL),#21	;LD HL,DATA
	INC	HL
	LD	A,(IX)
	LD	(HL),A
	INC	HL
	INC	IX
	LD	A,(IX)
	LD	(HL),A
	INC	HL
	INC	IX
	LD	(HL),#22	;LD (ADR),HL
	INC	HL
	LD	(HL),E
	INC	HL
	LD	(HL),D
	INC	HL
	INC	DE
	INC	DE
	DJNZ	CA0
	//------
	DUP	4
	LD	(HL),#00
	INC	HL
	EDUP
	LD	(HL),#AA	;XOR D
	INC	HL
	LD	(HL),#ED	;OUT (C),A (#ED79)
	INC	HL
	LD	(HL),#79
	INC	HL
	//------
	POP	DE
	LD	A,D
	XOR	%10000000
	LD	D,A
	PUSH	BC
	LD	BC,32
	ADD	IX,BC
	PUSH	IX	; 
	PUSH	IY
	POP	IX
	POP	IY
	POP	BC
	DEC	C
	JP	NZ,CA1
	//------
	PUSH	HL
	LD	HL,32
	ADD	HL,DE
	EX	DE,HL
	POP	HL
	EX	AF,AF
	DEC	A
	JP	NZ,CA2
	//------
	LD	(HL),#C9
	RET


//------------------------
ATTR0	EQU	$
	RET
ATTR1	EQU	$+9889
	ORG	ATTR1
	RET

ALLEND
//=========================================================
	LUA
	print (sj.get_label("ALLEND"))
	ENDLUA
//=========================================================
	EMPTYTRD "view8x2i.trd"
	SAVETRD "view8x2i.trd","CODE.C",PROGBEG,ALLEND-PROGBEG
//=========================================================
	ORG	#8000
BEGIMG	INCBIN	"image.mg2"
ENDIMG
	SAVETRD "view8x2i.trd","IMAGE.C",BEGIMG,ENDIMG-BEGIMG

//---
	ORG	#8000
	INCBIN	"boot.bin"
	SAVETRD "view8x2i.trd","boot.B",32768,256