//=========================================================
	DEVICE	ZXSPECTRUM128
//=========================================================
	ORG	#6400
PROGBEG
//------------------------------------------  , 
	LD	SP,#6400
	LD	BC,#7FFD
	LD	A,#17
	OUT	(C),A
//------------------------------------------   
	LD	HL,#5800
	LD	DE,#5801
	LD	BC,767
	LD	(HL),L
	LDIR
	LD	HL,#D800
	LD	DE,#D801
	LD	BC,767
	LD	(HL),L
	LDIR
//------------------------------------------  
HDR	EQU	#BD00
	LD	HL,HDR
	LD	DE,(23796)
	LD	BC,#0105
	CALL	#3D13	
//------------------------------------------  
	LD	HL,#4000	//6144
	LD	DE,(23796)
	LD	BC,#1805
	CALL	#3D13

	LD	HL,#C000	//6144
	LD	DE,(23796)
	LD	BC,#1805
	CALL	#3D13

	CALL	INTERL

//------------------------------------------  
	LD	HL,BUFF1	//1536
	LD	DE,(23796)
	LD	BC,#0605
	CALL	#3D13

	LD	HL,BUFF2	//1536
	LD	DE,(23796)
	LD	BC,#0605
	CALL	#3D13

//------------------------   
	DI
	LD	A,#BE
	LD	I,A
	IM	2
	LD	HL,#BE00
	LD	B,0
LL1	LD	(HL),#BF
	INC	HL
	DJNZ	LL1
	LD	(HL),#BF
	LD	HL,#BFBF
	LD	(HL),#C9
//------------------------

MAINLP	EI
	HALT
	LD	A,(HDR+5)
	OUT	(#FE),A
	LD	A,#17
	CALL	ATTR0
	//-------
	EI
	HALT
	LD	A,(HDR+6)
	OUT	(#FE),A
	LD	A,#17+#08
	CALL	ATTR1
	JP	MAINLP
//------------------------
ATTR0	LD	HL,BUFF1
	LD	DE,#5800
	CALL	MOVATR
	LD	HL,BUFF1+32
	LD	DE,#D800
	CALL	MOVATR
	LD	HL,BUFF1+1024
	LD	DE,#5A00
	JP	ATTR3
ATTR1	LD	HL,BUFF2
	LD	DE,#D800
	CALL	MOVATR
	LD	HL,BUFF2+32
	LD	DE,#5800
	CALL	MOVATR
	LD	HL,BUFF2+1024
	LD	DE,#DA00
	JP	ATTR3
ATTR3	LD	BC,#7FFD
	OUT	(C),A
	EX	AF,AF
	LD	A,46
	DEC	A
	JP	NZ,$-1
	LD	HX,16
	LD	LX,32
	PUSH	HL
	PUSH	DE
ATTR4	;---
	DUP	32
	LDI
	EDUP			;512
	LD	BC,32		;10
	ADD	HL,BC		;15
	LD	A,HX		;8
	CP	9		;7
	JP	NZ,ATTR5	;10 //562
	;---
	POP	DE	;10
	POP	HL	;10
	LD	BC,32	;10
	ADD	HL,BC	;15
	LD	A,D	;4
	XOR	#80	;7
	LD	D,A	;4
	JP	ATTR6	;10 /70
ATTR5	LD	A,4	;7
	LD	A,4	;7
	DEC	A	;4
	JP	NZ,$-1	;10	//70
ATTR6	;---
	; PAUSE 896-687=209
	LD	A,14	;7
	DEC	A	;4
	JP	NZ,$-1	;10
	DEC	BC	;6
	;---
	EX	AF,AF		;4
	LD	BC,#7FFD	;10
	XOR	#08		;7
	OUT	(C),A		;12
	EX	AF,AF		;4  //37
	;---
	DEC	HX		;8
	JP	NZ,ATTR4	;10 //18
ATTR7	;-------------
	LD	A,59	;7
	DEC	A	;4
	JP	NZ,$-1	;10 //826
	NOP		;4
	NOP		;4 - 841
	;---
	EX	AF,AF		;4
	LD	BC,#7FFD	;10
	XOR	#08		;7
	OUT	(C),A		;12
	EX	AF,AF		;4  //37
	;---
	DEC	LX		;8
	JP	NZ,ATTR7	;10 //18
	RET
MOVATR	;-----------
	DUP	16
	DUP	32
	LDI
	EDUP
	LD	BC,32
	ADD	HL,BC
	EDUP
	;---
	RET
//------------------------
INTERL	DI
	LD	HL,#4400
	LD	DE,#C400
	CALL	I2
	LD	HL,#4C00
	LD	DE,#CC00
	CALL	I2
	LD	HL,#5400
	LD	DE,#D400
I2	LD	A,4
I1	EX	AF,AF
	LD	B,0
	//---
I0	LD	A,(DE)
	LD	C,(HL)
	LD	(HL),A
	LD	A,C
	LD	(DE),A
	INC	L
	INC	E
	DJNZ	I0
	//---
	INC	D
	INC	H
	EX	AF,AF
	DEC	A
	JP	NZ,I1
	RET
//------------------------
BUFF1	EQU	#E000
BUFF2	EQU	BUFF1+1536

ALLEND
//=========================================================
	LUA
	print (sj.get_label("ALLEND"))
	ENDLUA
//=========================================================
	EMPTYTRD "view8x4.trd"
	SAVETRD "view8x4.trd","CODE.C",PROGBEG,ALLEND-PROGBEG
//=========================================================
	ORG	#0000
BEGIMG	INCBIN	"image.mg4"
ENDIMG
	SAVETRD "view8x4.trd","IMAGE.C",BEGIMG,ENDIMG-BEGIMG
//---
	ORG	#8000
	INCBIN	"boot.bin"
	SAVETRD "view8x4.trd","boot.B",32768,256
